varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D blendTexture;
uniform float intensity;
uniform float hueAdjust;

vec3 blendHUE(vec3 src1){
    vec3 yiq = rgb2yiq(src1);
    float hue = atan(yiq.z, yiq.y);
    float chroma = length(yiq.yz);
    hue -= hueAdjust;
    yiq.yz = vec2(cos(hue), sin(hue)) * chroma;
    return yiq2rgb(yiq);
}
void main()
{
    vec4 src = texture2D(inputImageTexture, textureCoordinate);
    vec4 dst = texture2D(blendTexture, textureCoordinate);
    if(hueAdjust != 0.0){
        dst.rgb = blendHUE(dst.rgb);
    }

    gl_FragColor = vec4(blend(src.rgb, dst.rgb, dst.a * intensity), src.a);
}